
// Description								/*{{{*/
// $Id: dudf.h,v 1.2 2008/01/29 13:04:48 prrt Exp $
/* ######################################################################
   
   DUDF - Distribution Upgradeability Description Format
   
   This class has a single global instance. 
   It is responsible for generating the DUDF file as defined in MANCOOSI 
   project.
   DUDF contais one problem instance.
   
   ##################################################################### */
									/*}}}*/
#ifndef PKGLIB_DUDF_H
#define PKGLIB_DUDF_H

#ifdef __GNUG__
#pragma interface "apt-pkg/dudf.h"
#endif 

    

#include <apt-pkg/strutl.h>
#include <apt-pkg/cmndline.h>
#include <rpmpackagedata.h>


//#define MAXDUDFPKG 20;
#define MAXBUFFER 16 * 1024

using std::string;

class GlobalDudf
{
  	bool generateUUID(string& uuid); 
  	bool isEssentialPackage(const string& packageName); 
        string dumpRPMDb();
	
	struct DudfPackageInfo
	{
			string Name;
			string VerRel;
			string Status;
			string DepBrokenName;
			string DepConstrain;
			string DepConstVersion;
			string DepCandidate;
			
	}; 
	
	vector<DudfPackageInfo> *PtrPkgInfo;
        RPMPackageData *rpmdata;
	
	struct DudfInfo
   {
      string Distribution;
      string InstallerName, InstallerVersion;
      string MetaInstallerName, MetaInstallerVersion;
      string InstallerDbFilename;
      // DudfPackageList SetDudfPackageLists[MAXDUDFPKG];
      
   };

	string FilenameFingerprint, Timestamp;
	string DudfErrorMsg;
	
	DudfInfo DudfInfoElement;
	
   
      public:
    	  
   // CNC:2003-02-24 - See above.
   //void SetDist(string InstallerName, string MetaInstallerVersion );
      
   // Usefull routine to dump to file
   bool DumpToFile(CommandLine &CmdL,string ResultStatus);
   bool SetDistro();
   bool PackageDb(string &pkgstatus);
   bool PackageDbJson(string &pkgstatus);
   bool PackageUniverse(vector<string> *PtrListFiles);
   void AddMsgError(string MsgErrorPart);
   void PackagesInfo(string PkgName, string PkgVerRel,string PkgStatus,string PkdDepBrokenName, 
		   string PkgDepConstrain,string PkgDepConstVersion,string PkgDepCandidate);
   
   
   GlobalDudf();
};
 

GlobalDudf *_GetDudfObj();
#define _dudf _GetDudfObj()


#endif

// vim:sts=3:sw=3
